# -*- coding: utf-8 -*-
from setuphelpers import *
import json
import base64
from waptcrypto import SSLCertificate
import waptguihelper
from common import WaptServer

encrypted_txt_file = "encrypted_txt.json"


def update_package():
    srvwapt_url = inifile_readstring(makepath(install_location("WAPT_is1"), "wapt-get.ini"), "global", "wapt_server")
    server = server = WaptServer()
    server.load_config_from_file(WAPT.config_filename)
    server.server_url = srvwapt_url

    credentials_url = waptguihelper.login_password_dialog("Credentials for WAPT Server", srvwapt_url, "admin", "")
    server.auth = lambda **kwargs: (credentials_url["user"], credentials_url["password"])

    encrypt_txt = waptguihelper.input_dialog("Encrypting with WAPT", "Enter the text to be encrypted: ", "")
    if not encrypt_txt:
        error("Please provide text to be encrypted")
    encrypt_dict = {}
    # data = json.loads(
    #     wgets(
    #         "https://%s:%s@%s/api/v1/hosts?columns=host_certificate&limit=10000" % (credentials_url["user"], credentials_url["password"], srvwapt_url)
    #     )
    # )
    data = server.get("/api/v3/hosts?columns=host_certificate&limit=1000000")["result"]

    for value in data:
        if value["host_certificate"]:
            host_cert = SSLCertificate(crt_string=value["host_certificate"])
            encrypt_dict[value["uuid"]] = base64.b64encode(host_cert.encrypt(encrypt_txt.encode("utf-8"))).decode("utf-8")
            print(value["computer_fqdn"] + ":" + value["uuid"] + ":" + encrypt_dict[value["uuid"]])

    json_write_file(encrypted_txt_file, encrypt_dict)
